package com.muyu.config.role;

import com.alibaba.druid.pool.DruidDataSource;
import com.muyu.common.core.utils.SpringUtils;
import com.muyu.config.DynamicDataSource;
import com.muyu.config.domain.model.DataSourceInfo;
import com.muyu.config.domain.model.EntInfo;
import com.muyu.config.factory.DruidDataSourceFactory;
import lombok.AllArgsConstructor;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassDescription:
 * @JdkVersion: 17
 * @Author: zhangxu
 * @Created: 2024/6/4 9:05
 */
@Log4j2
@Component
@AllArgsConstructor
public class ManyDataSource {

    @PostConstruct
    public void init(){
          new Thread(()-> {
              try {
                  Thread.sleep(5000);
              } catch (InterruptedException ignored) {}
              DruidDataSourceFactory druidDataSourceFactory = SpringUtils.getBean(DruidDataSourceFactory.class);
              DynamicDataSource dynamicDataSource =SpringUtils.getBean(DynamicDataSource.class);

              EntInfo entInfo = EntInfo.builder()
                      .entCode("ent_4587")
                      .ip("115.159.67.205")
                      .port(3307)
                      .build();
              DataSourceInfo dataSourceInfo = DataSourceInfo.getDataSourceInfo(entInfo.getEntCode(), entInfo.getIp(), entInfo.getPort());
              DruidDataSource druidDataSource = druidDataSourceFactory.create(dataSourceInfo);
              dynamicDataSource.put(dataSourceInfo.getKey(),druidDataSource);
        }).start();

    }


    private List<EntInfo> dataSourceInfoList(){
        List<EntInfo> list = new ArrayList<>();
        list.add(
                EntInfo.builder()
                        .entCode("ent_4587")
                        .ip("115.159.67.205")
                        .port(3307)
                        .build()
        );
        return list;

    }

    @Bean
    @Primary
    public DynamicDataSource dynamicDataSource(DruidDataSourceFactory druidDataSourceFactory) {
        Map<Object, Object> map = new HashMap<>();
        dataSourceInfoList().stream()
                        .map(entInfo -> DataSourceInfo.getDataSourceInfo(entInfo.getEntCode(),entInfo.getIp(),entInfo.getPort()))
                                .forEach(dataSourceInfo -> {
                                    map.put(dataSourceInfo.getKey(),druidDataSourceFactory.create(dataSourceInfo));
                                });

        //设置动态数据源
        DynamicDataSource dynamicDataSource = new DynamicDataSource();
        dynamicDataSource.setTargetDataSources(map);
        dynamicDataSource.setDefaultTargetDataSource(map);
        return dynamicDataSource;


    }






}
